import { defineStore } from 'pinia';
export interface UserStateType {
  info?: {
    username: string;
    avatar: string;
  } | null;
  token?: string | null;
}

export interface UserActionsType {
  login(): void;
  logout(): void;
  getUserRoutes(): void;
}

export default defineStore<'user', UserStateType, {}, UserActionsType>('user', {
  state: () => ({
    userinfo: {},
    token: localStorage.getItem('token'),
  }),
  actions: {
    login() {},
    logout() {},
    /** 后续可能的动态路由 */
    getUserRoutes() {},
  },
});
