import { UploadData } from '@/api/common';

/**
 *
 * @param divisor {number}
 * @param dividend {number}
 * @returns {string}
 */
export const getPercentage = (divisor: number, dividend: number) =>
  `${(divisor / dividend) * 100}%`;

export const getSession = <T extends any>(item: string) => {
  try {
    const store = sessionStorage.getItem(item);

    if (store) {
      return JSON.parse(store);
    }
  } catch (error) {}
};

export const setRequiredRules = (feild: string = '') => [
  { required: true, message: `${feild}必填` },
];

const images = ['.jpg', '.jpeg', '.png', '.gif', '.webp'];
const videos = [
  '.mp4',
  '.ogg',
  '.avi',
  '.mov',
  '.wmv',
  '.webm',
  '.ogm',
  '.ogv',
];

export const isVideo = (video: UploadData): Boolean => {
  if (video.fileName === '') return false;
  for (const type of videos) {
    const reg = new RegExp(`${type}`, 'g');
    if (video.fileName?.match(reg)) {
      return true;
    }
  }
  return false;
};

export const isImage = (image: UploadData): Boolean => {



    if (image.fileName === '' || image.fileName === null) return false;

  for (const type of images) {
    const reg = new RegExp(`${type}`, 'g');
    if (image.fileName?.match(reg)) {
      return true;
    }
  }
  return false;
};

export const sleep = (delay: number) =>
  new Promise((resolve) => {
    setTimeout(() => resolve(''), delay);
  });

export const BaseMediaUrl = ` ${(import.meta.env.VITE_API_SERVER as string)}/YJZH-SQ/api/common/download/resource?resource=`;
  // 'http://sqpcbg.xt.wenhq.top:8083/api/common/download/resource?resource=';