import {
  ref,
  defineComponent,
  onMounted,
  computed,
  onUnmounted,
  watch,
} from 'vue';
import { useRouter, useRoute } from 'vue-router';
import './index.scss';
import { useCommonStore, useIncidentStore } from '@/store';
import { BaseMediaUrl, isImage, isVideo } from '@/utils';
import {
  DropdownItemOption,
  NavBar,
  DropdownMenu,
  DropdownItem,
  Icon,
  PullRefresh,
  Sticky,
  Collapse,
  CollapseItem,
  Field,
  Button,
  Loading,
  Toast,
  Step,
  Steps,
  Dialog,
  ImagePreview,
  Popup,
  Tab,Tabs
} from 'vant';
/** @ts-ignore */
import icon_communication from '@/assets/icons/incident/communication@2x.png';
/** @ts-ignore */
import icon_detail from '@/assets/icons/incident/detail@2x.png';
/** @ts-ignore */
import icon_information from '@/assets/icons/incident/information@2x.png';
/** @ts-ignore */
import icon_plan from '@/assets/icons/incident/plan@2x.png';
/** @ts-ignore */
import icon_yjck from '@/assets/icons/incident/yjck@2x.png';
/** @ts-ignore */
import icon_yjya from '@/assets/icons/incident/yjya@2x.png';
/** @ts-ignore */
import icon_video from '@/assets/icons/incident/video.png';
import { cloneDeep, take } from 'lodash';



export default defineComponent({
  name: 'IncidentManagementDetail',
  setup() {
    const router = useRouter();

    const route = useRoute();

    const store = useIncidentStore();

    const commonStore = useCommonStore();

    const activeNames = ref([
      '事件信息',
      '应急预案',
      '处置方案',
      '处置详情',
      '融合通信',
    ]);
    const activeoplanNames = ref([
      
    ]);
    const message = ref('');
    const dosubmitdata = () => { 
      if (!store.incidentDetail.baseInfo?.id || message.value == "") {
        Toast.fail('信息不完整');
      }
        store.addIncidentProcess({
          incidentId: store.incidentDetail.baseInfo?.id,
          des: message.value,
          taskId:currenttaskid.value,
        }).then(() => { 
          message.value = "";
            store.getIncidentItem(store.incidentDetail.baseInfo?.id ?? '');
        });
      
      
    };

    const dohs = () => { 
      try {
         
        uni.postMessage({
          data: {
            type: 'RHTX_gotoMeetMember',
            data: 'yjzh',
          },
        });

      } catch (E) { 
      }
     
    }

    const planOptions = computed(
      () =>
        Object.keys(store.incidentDetail?.baseTask ?? {})
          .map((idx) => {
            const item = commonStore.globalDict['zhdd_incident_level']?.find(
              (i) =>
                i.dictValue ===
                store.incidentDetail?.baseTask?.[idx]?.[0].level?.toString(),
            );
            const desc = store.incidentDetail?.baseTask?.[idx]?.map((i) => [
              i.taskDes,
              i.taskName,
            ]);

            return {
              ...item,
              desc,
            };
          })
          ?.find(
            (item) =>
              item.dictValue?.toString() ===
              store.incidentDetail?.baseInfo?.level?.toString(),
          )?.desc
    );

    const currenttaskid = ref('');

    const process = ref([]);

    watch(
      () => store.incidentDetail.process,
      () => {
        var mkdtemp = {};
        store.incidentDetail.process?.map((i) => {
          var list = mkdtemp[i.taskId] ?? [];
          list.push(i);
          mkdtemp[i.taskId] = list;
        });
         console.log(mkdtemp);
        process.value = [];
        store.incidentDetail.process?.map((i) => {
          var list = cloneDeep(mkdtemp[i.taskId] ?? []);
          if (i.taskId && list.length > 0 && list[0].id === i.id) {
            list.splice(0, 1);
            process.value.push({
              ...i,
              child: list,
            });
          } else {
            if (!i.taskId) {
              process.value.push({
                ...i,
              });
            }
          }
           
        });
        console.log(process.value);
       

      },
    );

     const videop = ref();
     const videopsrc = ref('');
     const isshowprew = ref(false);
    onMounted(() => {
      commonStore.getGlobalDict('zhdd_incident_level');
      commonStore.getGlobalDict('zhdd_incident_type');
      commonStore.getGlobalDict('zhdd_incident_source');

      route.query.id && store.getIncidentItem(route.query.id as string);

      if (route.query.taskid) { 
         currenttaskid.value = route.query.taskid as string; 
      } 
    });

    const getisbj = () => { 
      if (currenttaskid.value == "")
        return true;
      var isok = false;
      store.incidentDetail.task?.map(ii => {
        if (ii.id == currenttaskid.value && ii.backLogFlag == "1") {
          isok = true;
        }
      })
      return isok;
    }

    onUnmounted(() => {
      store.incidentDetail = {};
    });

    return () => (
      <div class="incident-detail-container">
        <NavBar
          title="应急处置"
          left-arrow
          fixed
          onClick-left={() => {
            try {
              uni.navigateBack();
            } catch (E) {}
            //window.history.back();
          }}
          onClick-right={() => {
            if (getisbj()) {
              return;
            }
            Dialog.confirm({
              title: '提示',
              confirmButtonText: '办结',
              message: '点击办结按钮后，将无法继续反馈，请确认好是否完成！',
            })
              .then(() => {
                // on confirm
                store.putbackLog(currenttaskid.value);
                try {
                  uni.navigateBack();
                } catch (E) {}
              })
              .catch(() => {
                // on cancel
              });
          }}
          v-slots={{
            right: () => (getisbj() ? '' : <span class={'bjbtn'}>办结</span>),
          }}
        />
        <Sticky offsetTop={'46px'}>
          <div class="title">{store.incidentDetail?.baseInfo?.name}</div>
        </Sticky>
        <Popup
          style="width:100%;background:rgba(0,0,0,0)"
          v-model:show={isshowprew.value}
          onClose={() => {
            videop.value.pause();
          }}>
          <video
            ref={videop}
            src={videopsrc.value}
            controls
            autoplay="true"
            style="width:100%"></video>
        </Popup>

        <van-tabs color="#1777ff" swipeable={ true} title-active-color="#1777ff" v-model:active={activeNames.value}>
          <van-tab title-style={ "font-weight:500"} title="事件信息">
            <p>
              事件类型：
              {
                commonStore.globalDict['zhdd_incident_type']?.find(
                  (o) =>
                    o.dictValue.toString() ===
                    store.incidentDetail?.baseInfo?.type?.toString(),
                )?.dictLabel
              }
            </p>
            <p>
              事件等级：
              {
                commonStore.globalDict['zhdd_incident_level']?.find(
                  (o) =>
                    o.dictValue.toString() ===
                    store.incidentDetail?.baseInfo?.level?.toString(),
                )?.dictLabel
              }
            </p>
            <p>事件时间：{store.incidentDetail?.baseInfo?.createTime}</p>
            <p>事件地点：{store.incidentDetail?.baseInfo?.addr}</p>
            <p>
              事件来源：
              {commonStore.globalDict['zhdd_incident_source']?.find(
                (i) =>
                  i.dictValue?.toString() ===
                  (store.incidentDetail?.baseInfo?.source ?? '').toString(),
              )?.dictLabel ?? '-'}
            </p>
            <p>上报人员：{store.incidentDetail?.baseInfo?.createBy}</p>
            <p>联系电话：{store.incidentDetail?.baseInfo?.expr1}</p>
            <p>上报单位：{store.incidentDetail?.baseInfo?.createDept ?? '-'}</p>


          </van-tab>

          <van-tab title-style={"font-weight:500"} title="应急预案">
            {console.log(planOptions.value)}
            {planOptions.value?.map((d, index) => (
              <div style={"margin-bottom:10px"}>
                <div style={"color:#333"}>
                  {index + 1}、{d[0]}
                </div>
                <div style={"font-size:10px;padding-left:15px"}>{d[1]}</div>
              </div>
            ))}
          </van-tab>

          <van-tab title-style={"font-weight:500"} title="处置方案">
            <Collapse v-model={activeoplanNames.value}>
              {store.incidentDetail.task?.map((i) => (
                <div class="cz-item">
                  {i.taskName}
                  {/* <CollapseItem title={i.taskName} name={i.taskName}>
                    <div class="cz-zh">
                      {i.taskPersonVos
                        ?.map((p) => {
                          return p.person + p.position;
                        })
                        .join('、')}
                    </div>
                    <div>
                      <div class="zl">指令</div>
                      {i.taskCommandVos.map((c, index) => (
                        <div>
                          {index + 1}、{c.command}
                        </div>
                      ))}
                    </div>
                  </CollapseItem> */}
                </div>
              ))}
            </Collapse>
          </van-tab>


          <van-tab title-style={"font-weight:500"} title="处置详情">
            <div>
              {process.value?.map((i, index) => (
                <div class="czxq-item">
                  <div class="cz-yuan"></div>
                  <div
                    class="cz-line"
                    style={`display:${index === (process.value?.length ?? 0) - 1
                        ? 'none'
                        : 'block'
                      }`}></div>
                  <div class="cz-time"> {i.createTime}</div>
                  <div class="cz-des">
                    {' '}
                    {i.des}
                    <div
                      style={'margin-top: 4px;'}
                      class={i.taskId === currenttaskid.value ? 'active' : ''}>
                      {(i.child ?? [])?.map((ii, index) => (
                        <div class="czxq-item">
                          <div class="cz-yuan"></div>
                          <div
                            class="cz-line"
                            style={`display:${index === ((i.child ?? [])?.length ?? 0) - 1
                                ? 'none'
                                : 'block'
                              }`}></div>
                          <div class="cz-time"> {ii.createTime}</div>
                          <div class="cz-des">
                            <div style={'margin-bottom:8px'}>{ii.des}</div>

                            <div
                              class={'img'}
                              style={
                                ii.pic === '' && ii.video === ''
                                  ? 'display:none'
                                  : ''
                              }>
                              {((ii.pic ?? '') + ',' + (ii.video ?? '') ?? '')
                                .split(',')
                                .map((iim, idxq) => {
                                  iim = iim ?? '';
                                  if (isImage({ fileName: iim, url: iim })) {
                                    return (
                                      <img
                                        src={BaseMediaUrl + iim}
                                        onClick={() => {
                                          ImagePreview({
                                            images: ii.pic
                                              .split(',')
                                              .filter((cc) => cc != '')
                                              .map((cc) => {
                                                return BaseMediaUrl + cc;
                                              }),
                                            startPosition: idxq,
                                          });
                                        }}
                                        style={
                                          'width:20px;height:30px;object-fit: contain;margin-right:10px;padding:0 10px;background:rgb(240 236 236);'
                                        }></img>
                                    );
                                  }

                                  if (isVideo({ fileName: iim, url: iim })) {
                                    // console.log(iim);
                                    return (
                                      <img
                                        onClick={() => {
                                          isshowprew.value = true;
                                          try {
                                            videopsrc.value =
                                              BaseMediaUrl + iim;
                                            videop.value.play();
                                            videop.value.currentTime = 0;
                                          } catch (error) { }
                                        }}
                                        src={icon_video}
                                        style={
                                          'width:20px;height:30px;object-fit: contain;margin-right:10px;background:rgb(240 236 236);padding:0 10px;border-radius:4px'
                                        }></img>
                                    );
                                  }
                                  return <div></div>;
                                })}
                            </div>
                          </div>
                        </div>
                      ))}
                    </div>
                  </div>
                </div>
              ))}
              <div style={getisbj() ? 'display:none' : ''}>
                <Field
                  v-model={message.value}
                  autosize
                  type="textarea"
                  placeholder="请输入"
                />
                <div class="cz-action">
                  <Button
                    size="small"
                    type="primary"
                    onClick={() => {
                      dosubmitdata();
                    }}>
                    保存
                  </Button>
                  <Button
                    size="small"
                    type="default"
                    onClick={() => {
                      message.value = '';
                    }}>
                    取消
                  </Button>
                </div>
              </div>
            </div>
          </van-tab>


        </van-tabs>

        {
          false && (<Collapse v-model={activeNames.value}>
            <CollapseItem
              title="事件信息"
              name="事件信息"
              v-slots={{ icon: <img class="icon-i" src={icon_information} /> }}>
              <p>
                事件类型：
                {
                  commonStore.globalDict['zhdd_incident_type']?.find(
                    (o) =>
                      o.dictValue.toString() ===
                      store.incidentDetail?.baseInfo?.type?.toString(),
                  )?.dictLabel
                }
              </p>
              <p>
                事件等级：
                {
                  commonStore.globalDict['zhdd_incident_level']?.find(
                    (o) =>
                      o.dictValue.toString() ===
                      store.incidentDetail?.baseInfo?.level?.toString(),
                  )?.dictLabel
                }
              </p>
              <p>事件时间：{store.incidentDetail?.baseInfo?.createTime}</p>
              <p>事件地点：{store.incidentDetail?.baseInfo?.addr}</p>
              <p>
                事件来源：
                {commonStore.globalDict['zhdd_incident_source']?.find(
                  (i) =>
                    i.dictValue?.toString() ===
                    (store.incidentDetail?.baseInfo?.source ?? '').toString(),
                )?.dictLabel ?? '-'}
              </p>
              <p>上报人员：{store.incidentDetail?.baseInfo?.createBy}</p>
              <p>联系电话：{store.incidentDetail?.baseInfo?.expr1}</p>
              <p>上报单位：{store.incidentDetail?.baseInfo?.createDept ?? '-'}</p>
            </CollapseItem>
            <CollapseItem
              title="应急预案"
              name="应急预案"
              v-slots={{ icon: <img class="icon-i" src={icon_yjya} /> }}>
              {console.log(planOptions.value)}
              {planOptions.value?.map((d, index) => (
                <div style={"margin-bottom:10px"}>
                  <div style={"color:#333"}>
                    {index + 1}、{d[0]}
                  </div>
                  <div style={"font-size:10px;padding-left:15px"}>{d[1]}</div>
                </div>
              ))}
            </CollapseItem>
            <CollapseItem
              title="处置方案"
              name="处置方案"
              v-slots={{ icon: <img class="icon-i" src={icon_plan} /> }}>
              <Collapse v-model={activeoplanNames.value}>
                {store.incidentDetail.task?.map((i) => (
                  <div class="cz-item">
                    {i.taskName}
                    {/* <CollapseItem title={i.taskName} name={i.taskName}>
                    <div class="cz-zh">
                      {i.taskPersonVos
                        ?.map((p) => {
                          return p.person + p.position;
                        })
                        .join('、')}
                    </div>
                    <div>
                      <div class="zl">指令</div>
                      {i.taskCommandVos.map((c, index) => (
                        <div>
                          {index + 1}、{c.command}
                        </div>
                      ))}
                    </div>
                  </CollapseItem> */}
                  </div>
                ))}
              </Collapse>
            </CollapseItem>
            <CollapseItem
              title="处置详情"
              name="处置详情"
              v-slots={{ icon: <img class="icon-i" src={icon_detail} /> }}>
              <div>
                {process.value?.map((i, index) => (
                  <div class="czxq-item">
                    <div class="cz-yuan"></div>
                    <div
                      class="cz-line"
                      style={`display:${index === (process.value?.length ?? 0) - 1
                          ? 'none'
                          : 'block'
                        }`}></div>
                    <div class="cz-time"> {i.createTime}</div>
                    <div class="cz-des">
                      {' '}
                      {i.des}
                      <div
                        style={'margin-top: 4px;'}
                        class={i.taskId === currenttaskid.value ? 'active' : ''}>
                        {(i.child ?? [])?.map((ii, index) => (
                          <div class="czxq-item">
                            <div class="cz-yuan"></div>
                            <div
                              class="cz-line"
                              style={`display:${index === ((i.child ?? [])?.length ?? 0) - 1
                                  ? 'none'
                                  : 'block'
                                }`}></div>
                            <div class="cz-time"> {ii.createTime}</div>
                            <div class="cz-des">
                              <div style={'margin-bottom:8px'}>{ii.des}</div>

                              <div
                                class={'img'}
                                style={
                                  ii.pic === '' && ii.video === ''
                                    ? 'display:none'
                                    : ''
                                }>
                                {((ii.pic ?? '') + ',' + (ii.video ?? '') ?? '')
                                  .split(',')
                                  .map((iim, idxq) => {
                                    iim = iim ?? '';
                                    if (isImage({ fileName: iim, url: iim })) {
                                      return (
                                        <img
                                          src={BaseMediaUrl + iim}
                                          onClick={() => {
                                            ImagePreview({
                                              images: ii.pic
                                                .split(',')
                                                .filter((cc) => cc != '')
                                                .map((cc) => {
                                                  return BaseMediaUrl + cc;
                                                }),
                                              startPosition: idxq,
                                            });
                                          }}
                                          style={
                                            'width:20px;height:30px;object-fit: contain;margin-right:10px;padding:0 10px;background:rgb(240 236 236);'
                                          }></img>
                                      );
                                    }

                                    if (isVideo({ fileName: iim, url: iim })) {
                                      // console.log(iim);
                                      return (
                                        <img
                                          onClick={() => {
                                            isshowprew.value = true;
                                            try {
                                              videopsrc.value =
                                                BaseMediaUrl + iim;
                                              videop.value.play();
                                              videop.value.currentTime = 0;
                                            } catch (error) { }
                                          }}
                                          src={icon_video}
                                          style={
                                            'width:20px;height:30px;object-fit: contain;margin-right:10px;background:rgb(240 236 236);padding:0 10px;border-radius:4px'
                                          }></img>
                                      );
                                    }
                                    return <div></div>;
                                  })}
                              </div>
                            </div>
                          </div>
                        ))}
                      </div>
                    </div>
                  </div>
                ))}
                <div style={getisbj() ? 'display:none' : ''}>
                  <Field
                    v-model={message.value}
                    autosize
                    type="textarea"
                    placeholder="请输入"
                  />
                  <div class="cz-action">
                    <Button
                      size="small"
                      type="primary"
                      onClick={() => {
                        dosubmitdata();
                      }}>
                      保存
                    </Button>
                    <Button
                      size="small"
                      type="default"
                      onClick={() => {
                        message.value = '';
                      }}>
                      取消
                    </Button>
                  </div>
                </div>
              </div>
            </CollapseItem>
            <CollapseItem
              title="融合通信"
              name="融合通信"
              v-slots={{ icon: <img class="icon-i" src={icon_communication} /> }}>
              <Button
                size="small"
                type="primary"
                onClick={() => {
                  dohs();
                }}>
                发起协同会商
              </Button>
            </CollapseItem>
          </Collapse>)
        }
        
      </div>
    );
  },
});
